import { Never, NeverType } from "../never";
import { AnyType } from "../any";
import { Const, ConstType } from "../const";
import { Enum, EnumType, EnumValues } from "../enum";
import { PrimitiveType } from "../primitive";
import { ArrayType } from "../array";
import { TupleType } from "../tuple";
import { ObjectType } from "../object";
import { UnionType } from "../union";
import { SerializableType, Type } from "../type";
import { $Intersect } from "./index";
import { IntersectConstToEnum } from "./const";
import { DistributeIntersection } from "./union";
import { IntersectDeserialized, IntersectIsSerialized } from "./utils";
export declare type MergeEnumValuesToSerializable<V, A extends EnumType, B extends SerializableType> = Enum<V, IntersectIsSerialized<A, B>, IntersectDeserialized<A, B>>;
export declare type IntersectEnum<A extends EnumType, B> = B extends Type ? B extends NeverType ? B : B extends AnyType ? MergeEnumValuesToSerializable<EnumValues<A>, A, B> : B extends ConstType ? IntersectConstToEnum<B, A> : B extends EnumType ? FilterUnintersecting<A, B> : B extends PrimitiveType ? IntersectEnumToPrimitive<A, B> : B extends ArrayType ? FilterUnintersecting<A, B> : B extends TupleType ? FilterUnintersecting<A, B> : B extends ObjectType ? FilterUnintersecting<A, B> : B extends UnionType ? DistributeIntersection<B, A> : Never : Never;
declare type FilterUnintersecting<A extends EnumType, B extends SerializableType> = MergeEnumValuesToSerializable<RecurseOnEnumValues<EnumValues<A>, B>, A, B>;
declare type RecurseOnEnumValues<V, B> = V extends infer T ? $Intersect<Const<T>, B> extends Never ? never : T : never;
export declare type IntersectEnumToPrimitive<A extends EnumType, B extends PrimitiveType> = FilterUnintersecting<A, B>;
export declare type IntersectEnumToArray<A extends EnumType, B extends ArrayType> = FilterUnintersecting<A, B>;
export declare type IntersectEnumToTuple<A extends EnumType, B extends TupleType> = FilterUnintersecting<A, B>;
export declare type IntersectEnumToObject<A extends EnumType, B extends ObjectType> = FilterUnintersecting<A, B>;
export {};
